searchNodes=[{"doc":"Struct for representing an application.","ref":"SqlMembershipProvider.Application.html","title":"SqlMembershipProvider.Application","type":"module"},{"doc":"Fetch an application by ID.","ref":"SqlMembershipProvider.Application.html#find_by_application_id/1","title":"SqlMembershipProvider.Application.find_by_application_id/1","type":"function"},{"doc":"Fetch an application by case-insensitive application name.","ref":"SqlMembershipProvider.Application.html#find_by_application_name/1","title":"SqlMembershipProvider.Application.find_by_application_name/1","type":"function"},{"doc":"","ref":"SqlMembershipProvider.Application.html#t:t/0","title":"SqlMembershipProvider.Application.t/0","type":"type"},{"doc":"Struct for representing a user's membership to an application and their authentication information.","ref":"SqlMembershipProvider.Membership.html","title":"SqlMembershipProvider.Membership","type":"module"},{"doc":"Fetch a membership by user id.","ref":"SqlMembershipProvider.Membership.html#find_by_user_id/1","title":"SqlMembershipProvider.Membership.find_by_user_id/1","type":"function"},{"doc":"Check if a plaintext password matches a user's hashed password.","ref":"SqlMembershipProvider.Membership.html#is_password_valid?/2","title":"SqlMembershipProvider.Membership.is_password_valid?/2","type":"function"},{"doc":"","ref":"SqlMembershipProvider.Membership.html#t:t/0","title":"SqlMembershipProvider.Membership.t/0","type":"type"},{"doc":"Struct for representing a user's profile information that may contain arbitrary properties","ref":"SqlMembershipProvider.Profile.html","title":"SqlMembershipProvider.Profile","type":"module"},{"doc":"Fetch a profile by user id.","ref":"SqlMembershipProvider.Profile.html#find_by_user_id/1","title":"SqlMembershipProvider.Profile.find_by_user_id/1","type":"function"},{"doc":"Parse a profile's property fields into a map.","ref":"SqlMembershipProvider.Profile.html#properties/1","title":"SqlMembershipProvider.Profile.properties/1","type":"function"},{"doc":"","ref":"SqlMembershipProvider.Profile.html#t:t/0","title":"SqlMembershipProvider.Profile.t/0","type":"type"},{"doc":"Struct for representing a security role that a user may assume","ref":"SqlMembershipProvider.Role.html","title":"SqlMembershipProvider.Role","type":"module"},{"doc":"Fetch all roles that a user belongs to.","ref":"SqlMembershipProvider.Role.html#find_by_user_id/1","title":"SqlMembershipProvider.Role.find_by_user_id/1","type":"function"},{"doc":"","ref":"SqlMembershipProvider.Role.html#t:t/0","title":"SqlMembershipProvider.Role.t/0","type":"type"},{"doc":"Struct for representing a user.","ref":"SqlMembershipProvider.User.html","title":"SqlMembershipProvider.User","type":"module"},{"doc":"Fetch a user by user ID.","ref":"SqlMembershipProvider.User.html#find_by_user_id/1","title":"SqlMembershipProvider.User.find_by_user_id/1","type":"function"},{"doc":"Fetch a user by case-insensitive username.","ref":"SqlMembershipProvider.User.html#find_by_user_name/1","title":"SqlMembershipProvider.User.find_by_user_name/1","type":"function"},{"doc":"Fetch a user by case-insensitive username and case-insensitive application name.","ref":"SqlMembershipProvider.User.html#find_by_user_name/2","title":"SqlMembershipProvider.User.find_by_user_name/2","type":"function"},{"doc":"","ref":"SqlMembershipProvider.User.html#t:t/0","title":"SqlMembershipProvider.User.t/0","type":"type"},{"doc":"","ref":"SqlMembershipProvider.UnsupportedPasswordFormatError.html","title":"SqlMembershipProvider.UnsupportedPasswordFormatError","type":"exception"},{"doc":"ChangelogAll notable changes to this project will be documented in this file.The format is based on Keep a Changelog, and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - [Unreleased]","type":"extras"},{"doc":"ChangedUpdated dependenciesUse typed_ecto_schema to reduce boilerplate","ref":"changelog.html#0-3-2-2020-10-06","title":"Changelog - [0.3.2] - 2020-10-06","type":"extras"},{"doc":"AddedUser.find_by_user_name/2 that accepts an application name. This lets you distinguish between users with the same username on different applications.DeprecatedUser.find_by_user_name/1 which could return multiple users with the same username, but different applications. Use User.find_by_user_name/2 instead.","ref":"changelog.html#0-3-1-2020-10-06","title":"Changelog - [0.3.1] - 2020-10-06","type":"extras"},{"doc":"ChangedConvert library to use Ecto. All structs are now Ecto schemas, and find_* functions return Ecto.Query which you must pass to a Ecto.Repo to get results.RemovedRemoved the SqlMembershipProvider.TdsUtils module because Ecto takes care of these things for us.","ref":"changelog.html#0-3-0-2020-09-25","title":"Changelog - [0.3.0] - 2020-09-25","type":"extras"},{"doc":"ChangedUpdated dependencies","ref":"changelog.html#0-2-0-2020-09-11","title":"Changelog - [0.2.0] - 2020-09-11","type":"extras"},{"doc":"AddedUser.find_by_user_id/2","ref":"changelog.html#0-1-2-2020-03-11","title":"Changelog - [0.1.2] - 2020-03-11","type":"extras"},{"doc":"FixedAllow nil field values to pass through TdsUtils.stringify_uuids/2 without error.","ref":"changelog.html#0-1-1-2019-08-23","title":"Changelog - [0.1.1] - 2019-08-23","type":"extras"},{"doc":"AddedInitial release","ref":"changelog.html#0-1-0-2019-08-09","title":"Changelog - [0.1.0] - 2019-08-09","type":"extras"},{"doc":"SqlMembershipProviderHex.pm DocumentationRead and authenticate against ASP.NET Membership Microsoft SQL Server databases.Do you have an ASP.NET app that uses the built-in Membership Provider that stores users, passwords, roles, and profiles in a Microsoft SQL Server database?This library lets your Elixir code talk to a Membership Provider database to lookup users, their profile information roles they belong to, and authenticate their passwords.This library uses Tds and Ecto to connect to a Microsoft SQL Server database.","ref":"readme.html","title":"SqlMembershipProvider","type":"extras"},{"doc":"First you must define an Ecto.Repo to connect to the MSSQL database:defmodule MyApp.Repo do use Ecto.Repo, otp_app: :my_app, adapter: Ecto.Adapters.Tds endMake sure to configure your database credentials:config :my_app, MyApp.Repo, database: &quot;aspnetdb&quot;, hostname: &quot;localhost&quot;, password: &quot;password&quot;, port: 1433, username: &quot;username&quot;Now you can query for users:iex(1)&gt; user = SqlMembershipProvider.User.find_by_user_name(&quot;JohnDoe&quot;) %SqlMembershipProvider.User{ ... } iex(2)&gt; membership = SqlMembershipProvider.Membership.find_by_user_id(user.user_id) %SqlMembershipProvider.Membership{ ... } iex(3)&gt; SqlMembershipProvider.Membership.is_password_valid?(membership, &quot;password!&quot;) true iex(4)&gt; profile = SqlMembershipProvider.Profile.find_by_user_id(user.user_id) %SqlMembershipProvider.Profile{ ... } iex(5)&gt; SqlMembershipProvider.Profile.properties(profile) %{ &quot;FirstName&quot; =&gt; &quot;John&quot;, &quot;LastName&quot; =&gt; &quot;Doe&quot;, ... } iex(6)&gt; roles = SqlMembershipProvider.Role.find_by_user_id(user.user_id) [ %SqlMembershipProvider.Role{ role_name: &quot;Administrators&quot;, ... } ]","ref":"readme.html#usage","title":"SqlMembershipProvider - Usage","type":"extras"},{"doc":"Clone the repo and fetch its dependencies:$ git clone https://gitlab.com/horse-racing-labs/sql_membership_provider.git $ cd sql_membership_provider $ mix deps.getDocker Compose is required to run a sample SQL Server database to run integration tests against.$ docker-compose up $ ./setup-test-database.sh $ mix test","ref":"readme.html#running-tests","title":"SqlMembershipProvider - Running Tests","type":"extras"},{"doc":"There are tables remaining to be mapped to schemas. Functions to update data like the password and profile properties still need to be implemented.","ref":"readme.html#future-work","title":"SqlMembershipProvider - Future Work","type":"extras"},{"doc":"Only the SHA1 password format is supported. Support should be added for the remaining password formats.Add support for reading binary properties from profiles","ref":"readme.html#help-wanted","title":"SqlMembershipProvider - Help Wanted","type":"extras"}]